KASLR绕过及提权利用（CVE-2023-35001）

2024-04-11 08:30:30

![](https://image.3001.net/images/20240308/1709876354_65eaa4828e91d155430d9.png) 本文由 创作，已纳入「FreeBuf原创奖励计划」，未授权禁止转载

前言
==

本文将介绍如何绕过`KASLR`以及如何提权利用。

KASLR绕过
=======

可以利用`byteorder`操作加上`netlink`组订阅可以泄露`rule`中的`handle`字段。该方法应该是可以用来泄露`kernel`基地址的，但是作者还提出另一种方法进行泄露。应该是为了提权利用做铺垫。

由于发现已经泄露的模块的基地址，因此可以利用模块地址伪造表达式。

作者找到了`range`表达式，用于伪造其余表达式。总大小为`0x23`。并且表达式是八字节对齐的，因此该结构体会占用`0x28`字节。

struct nft\_range\_expr {  
struct nft\_data     data\_from;  
struct nft\_data     data\_to;  
u8          sreg;  
u8          len;  
enum nft\_range\_ops  op:8;  
};

具体的布局如下

![image-20240227185357673](https://image.3001.net/images/20240411/1712795430_66172f26dd7f46c0ff9c4.png)

可以看到`data_from`与`data_to`都是从用户态中传递过去的数据，因此我们可以在这些区域内伪造表达式，这有点像在`CTF`中，我们泄露了堆块基址后，随意伪造堆块。

由于我们有`0x28`字节的空间，但是实际能够操作的空间是`data_from`与`data_to`两段，即`0x20`的空间大小。因此我们需要挑选小于`0x20`的规则表达式进行伪造，并且能够执行泄露功能的。

这里作者选用了`byteorder`表达式，可以看到该表达式在对齐后只占用八字节。

struct nft\_byteorder {  
u8          sreg;  
u8          dreg;  
enum nft\_byteorder\_ops  op:8;  
u8          len;  
u8          size;  
};

构造后，可以发现还有八字节的`data_to`没有用，但是并不能直接丢弃不适用，因为在调用完`byteorder`操作后还需要继续执行其他规则表达式。

![image-20240227190243722](https://image.3001.net/images/20240411/1712795431_66172f27af94a95d155fa.png)

但是其他表达式都是需要大于`0x8`的，毕竟一个操作指针就占用八字节了，此时作者选用了`meta`表达式。可以看到`meta`表达式也只用到了三个字节，刚好对应`range`表达式的`sreg`、`len`以及`op`。

struct nft\_meta {  
enum nft\_meta\_keys  key:8;  
u8          len;  
union {  
u8      dreg;  
u8      sreg;  
};  
};

`meta`表达式的操作如下，在`meta`表达式中`meta->key`执行具体的操作，如\[1\]，但是若该值是非法值则会执行\[2\]，可以看到该`meta`表达式仅会抛出异常，但是不会终止运行，这就说明即使`meta->key`是非法值也不会影响后续规则表达式的正常执行。

File: linux-5.19\\net\\netfilter\\nft\_meta.c  
418: void nft\_meta\_set\_eval(const struct nft\_expr \*expr,  
419:               struct nft\_regs \*regs,  
420:               const struct nft\_pktinfo \*pkt)  
421: {  
422:    const struct nft\_meta \*meta = nft\_expr\_priv(expr);  
423:    struct sk\_buff \*skb = pkt->skb;  
424:    u32 \*sreg = &regs->data\[meta->sreg\];  
425:    u32 value = \*sreg;  
426:    u8 value8;  
427:   
428:    switch (meta->key) { ----> \[1\]  
429:    case NFT\_META\_MARK:  
430:        skb->mark = value;  
431:        break;  
432:    case NFT\_META\_PRIORITY:  
433:        skb->priority = value;  
434:        break;  
435:    case NFT\_META\_PKTTYPE:  
436:        value8 = nft\_reg\_load8(sreg);  
437:   
438:        if (skb->pkt\_type != value8 &&  
439:            skb\_pkt\_type\_ok(value8) &&  
440:            skb\_pkt\_type\_ok(skb->pkt\_type))  
441:            skb->pkt\_type = value8;  
442:        break;  
443:    case NFT\_META\_NFTRACE:  
444:        value8 = nft\_reg\_load8(sreg);  
445:   
446:        skb->nf\_trace = !!value8;  
447:        break;  
448: #ifdef CONFIG\_NETWORK\_SECMARK  
449:    case NFT\_META\_SECMARK:  
450:        skb->secmark = value;  
451:        break;  
452: #endif  
453:    default:  
454:        WARN\_ON(1); ---->\[2\]  
455:    }  
456: }

因此第二个伪造的表达式也找到了，就是`meta`表达式。由于我们直接伪造了规则表达式，因此不会进行寄存器参数的校验，只要选择内核地址选择泄露即可。

![image-20240227191748571](https://image.3001.net/images/20240411/1712795432_66172f28980e170dea0be.png)

这里简单说一下伪造的规则头，此时的`len`需要设置为0x20以及`islast`需要设置为0。

最后泄露的效果如下，即使内核已经抛出了异常，但是不会影响后续表达式的正常执行。

![image-20240227192131407](https://image.3001.net/images/20240411/1712795436_66172f2c28463769ddca5.png)

【----帮助网安学习，以下所有学习资料免费领！加vx：dctintin，备注“freebuf”获取！】

① 网安学习成长路径思维导图  
② 60+网安经典常用工具包  
③ 100+SRC漏洞分析报告  
④ 150+网安攻防实战技术电子书  
⑤ 最权威CISSP 认证考试指南+题库  
⑥ 超1800页CTF实战技巧手册  
⑦ 最新网安大厂面试题合集（含答案）  
⑧ APP客户端安全检测指南（安卓+IOS）

提权利用
====

既然可以随意伪造表达式，因此我们可以伪造`payload`表达式。

struct nft\_payload {  
enum nft\_payload\_bases  base:8;  
u8          offset;  
u8          len;  
u8          dreg;  
};

![image-20240227194109554](https://image.3001.net/images/20240411/1712795437_66172f2d7f4070cc889b6.png)

在`regs`下方存在着`nft_do_chain`函数返回地址，因此可以直接通过`payload`表达式将提权`payload`注入进来。

![image-20240227194544551](https://image.3001.net/images/20240411/1712795438_66172f2e8911c94b102af.png)

由于我们可以伪造`payload`表达式，因此注入的`payload`长度不受限，因此采用

*   `commit_creds(prepare_kernel_cred(0))`，构造`root`凭证
    
*   接着利用`find_task_by_vpid`、`init_nsproxy`以及`switch_task_namespaces`切换命名空间。
    
*   最后利用蹦床`swapgs_restore_regs_and_retrun_to_usermode`返回到用户空间完成提权利用。
    

![image-20240227195613084](https://image.3001.net/images/20240411/1712795440_66172f3051496ba626dba.png)

完整`exp`：[https://github.com/h0pe-ay/Vulnerability-Reproduction/tree/master/CVE-2023-35001(nftables)](https://github.com/h0pe-ay/Vulnerability-Reproduction/tree/master/CVE-2023-35001(nftables))

\# 漏洞挖掘 \# 提权 \# 漏洞利用 \# 绕过